/* test.c */

/*

Copyright Notice:

Copyright (C) 2013 R Veera Kumar

This file is part of v-tools.

v-tools is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

v-tools is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with v-tools.  If not, see <http://www.gnu.org/licenses/>.

See the COPYING file distributed together for license information.

See the AUTHOR file distributed together for authors information.

*/

#include "test.h"

/* USAGE: test [ -n | -nn ] | [ -si | -sd | -sr ] | -fs size | -i FILE | -o FILE | -h */

int main ( int argc, char *argv[] )

 {

  uint8_t *mem_bufa, *mem_bufb;
  int arg_i, arg_o, arg_n, arg_nn, arg_si, arg_sd, arg_sr, arg_fs;
  arg_i = arg_o = arg_n = arg_nn = arg_si = arg_sd = arg_sr = arg_fs = 0;
  int cnt, sv, next_sv, l , k, stat, stat2, iter;

  next_sv = 0;

  size_t read_sum, write_sum, i, j;
  long int size, size_sum;
  ap_ctx ap;

  FILE *fpin;
  FILE *fpout;
  char *ifn, *ofn, *size_str;
  char *ifn_def = "/dev/urandom";
  ifn = NULL;
  fpout = stdout;

  if ( argc > 9 )
   { usage(); exit(1); }

  if ( argc == 1 ) exit(0);


  cnt = 1;
  while ( cnt <= (argc-1) )
   {

    if ( strcmp(argv[cnt], "-i") == 0 )
     {
      if ( arg_i != 1 )
       { arg_i = 1; if ( (cnt+1) > (argc-1) ) { opt_arg_err(); exit(1); }; ifn = argv[cnt+1]; cnt +=2; continue;
}
      else { opt_err(); usage(); exit(1); }
     }

    else if ( strcmp(argv[cnt], "-o") == 0 )
     {
      if ( arg_o != 1 )
       { arg_o = 1; if ( (cnt+1) > (argc-1) ) { opt_arg_err(); exit(1); }; ofn = argv[cnt+1]; cnt +=2; continue;
}
      else { opt_err(); usage(); exit(1); }
     }

    else if ( strcmp(argv[cnt], "-fs") == 0 )
     {
      if ( arg_fs != 1 )
       { arg_fs = 1; if ( (cnt+1) > (argc-1) ) { opt_arg_err(); exit(1); }; size_str = argv[cnt+1]; cnt +=2; continue;
}
      else { opt_err(); usage(); exit(1); }
     }

    else if ( strcmp(argv[cnt], "-n") == 0 ) { arg_n = 1; ++cnt; continue; }
    else if ( strcmp(argv[cnt], "-nn") == 0 ) { arg_nn = 1; ++cnt; continue; }
    else if ( strcmp(argv[cnt], "-si") == 0 ) { arg_si = 1; ++cnt; continue; }
    else if ( strcmp(argv[cnt], "-sd") == 0 ) { arg_sd = 1; ++cnt; continue; }
    else if ( strcmp(argv[cnt], "-sr") == 0 ) { arg_sr = 1; ++cnt; continue; }

    else if ( strcmp(argv[cnt], "-h") == 0 ) { usage(); exit(0); }
    else { parm_unknown_err(argv[cnt]); usage(); exit(1); }

   }

  if ( !arg_n && !arg_nn)
   {
    fputs("You have to give -n or -nn argument.\n", stderr);
    exit(1);
   }

  if ( arg_n || arg_nn)
   if ( !((arg_si || arg_sd || arg_sr) && arg_fs ) )
    {
     fputs("You have to give -fs and one of -si -sd -sr arguments.\n", stderr); 
     exit(1);
    }


  if ( (mem_bufa = malloc(BUFSIZE)) == NULL ) { mem_alloc_err(); exit(1); }
  if ( (mem_bufb = malloc(BUFSIZE * 3)) == NULL ) { mem_alloc_err(); exit(1); }

  if ( arg_i == 1 )
   {
    if ( (fpin = fopen(ifn, "r")) == NULL ) { file_open_err(); exit(1); }
   }
  else
   {
    if ( (fpin = fopen(ifn_def, "r")) == NULL ) { file_open_err(); exit(1); }
   }

  if ( arg_o == 1 )
   {
    if ( (fpout = fopen(ofn, "w")) == NULL ) { file_open_err(); exit(1); }
   }

  size = strtol(size_str, NULL, 10);

  if ( arg_si )
   sv = 1;
  else if ( arg_sd )
   {
    if ( arg_n == 1 )
     {
      ap_calc ( 2, size, &ap );
      sv = size - ap.sum - 1;
      iter = 3 + ap.iter - 1 - 2;
     }
    if ( arg_nn == 1 )
     {
      ap_calc ( 3, size, &ap );
      if ( size == ap.sum )
       {
        sv = 3 + ap.iter - 1 - 2;
        iter = ap.iter - 1;
       }
      if ( (size - ap.sum) >= 3 )
       {
        sv = size - ap.sum - 2;
        iter = ap.iter;
       }
      if ( (size - ap.sum) == 1 )
       {
        sv = 1;
        next_sv = 3 + ap.iter - 1 - 2 - 2;
        iter = ap.iter;
       }
      if ( (size - ap.sum) == 2 )
       {
        sv = 0;
        iter = ap.iter;
       }
     }
   }
  else if ( arg_sr )
   {
    sv =  ( getc(fpin) << 3 );
    sv |=  ( getc(fpin) << 2 );
    sv |=  ( getc(fpin) << 1 );
    sv |=  ( getc(fpin) );
    srand( (unsigned int) sv);
    if ( arg_n == 1 ) sv = rand()%(size-1);
    else if ( arg_nn == 1 ) sv = rand()%(size-2+1);
   }

  size_sum = 0;
  k = sv;
  l = 0;
  stat = 0;
  stat2 = 0;

  do
   {

    read_sum = readtobuf ( mem_bufa, BUFSIZE, fpin );

    if ( read_sum > 0 )

     {

      i = 0;
      j = 0;
      while ( i < read_sum )
       {

        if ( arg_si == 1 )
         {
          if ( size_sum == size - 1 )
           {
            *(mem_bufb+j++) = '\0';
            ++size_sum;
            break;
           }
          if ( (size_sum == size - 3) && ( (k - l) == 1 ) && ( arg_nn == 1) )
           {
            l = k;
            continue;
           }
          if ( (stat == 0) && ( arg_nn == 1) )
           {
            *(mem_bufb+j++) = '\0';
            ++size_sum;
            stat = 1;
            continue;
           }
          if ( (l < k) )
           {
            if ( *(mem_bufa+i) != 0 ) *(mem_bufb+j++) = *(mem_bufa+i++);
            else { ++i; continue; }
            ++size_sum;
            ++l;
           }
          else
           {
            l = 0;
            ++k;
            *(mem_bufb+j++) = '\0';
            ++size_sum;
            if (arg_nn == 1) stat = 0;
           }
         }

        if ( arg_sr == 1 )
         {
          if ( size_sum == size - 1 )
           {
            *(mem_bufb+j++) = '\0';
            ++size_sum;
            break;
           }
          if ( (size_sum == size - 3) && ( stat == 0 ) && ( arg_nn == 1) )
           {
            *(mem_bufb+j++) = '\0';
            ++size_sum;
            stat = 1;
            stat2 = 1;
            continue;
           }
          if ( stat2 == 1 )
           {
            if ( *(mem_bufa+i) != 0 ) *(mem_bufb+j++) = *(mem_bufa+i++);
            else { ++i; continue; }
            ++size_sum;
            continue;
           }
          if ( (size_sum == size - 2) && ( k == l ) && ( l != 0 ) && ( arg_nn == 1) )
           {
            if ( *(mem_bufa+i) != 0 ) *(mem_bufb+j++) = *(mem_bufa+i++);
            else { ++i; continue; }
            ++size_sum;
            continue;
           }
          if ( (stat == 0) && ( arg_nn == 1) )
           {
            *(mem_bufb+j++) = '\0';
            ++size_sum;
            stat = 1;
            continue;
           }
          if ( (l < k) )
           {
            if ( *(mem_bufa+i) != 0 ) *(mem_bufb+j++) = *(mem_bufa+i++);
            else { ++i; continue; }
            ++size_sum;
            ++l;
           }
          else
           {
            l = 0;
            *(mem_bufb+j++) = '\0';
            ++size_sum;
            if (arg_n == 1) k = rand()%( (size-size_sum-1-1) == 0 ? 1 : (size-size_sum-1-1) ) ;
            if (arg_nn == 1)
             {
              stat = 0;
              k = rand() % ( (size-size_sum-1-2+1) == 0 ? 1 : size-size_sum-1-2+1);
             }
           }

         }

        if ( arg_sd == 1 )
         {
          if ( size_sum == size - 1 )
           {
            *(mem_bufb+j++) = '\0';
            ++size_sum;
            break;
           }
          if ( (stat == 0) && ( arg_nn == 1) )
           {
            *(mem_bufb+j++) = '\0';
            ++size_sum;
            stat = 1;
            continue;
           }
          if ( (l < k) )
           {
            if ( *(mem_bufa+i) != 0 ) *(mem_bufb+j++) = *(mem_bufa+i++);
            else { ++i; continue; }
            ++size_sum;
            ++l;
           }
          else
           {
            l = 0;
            *(mem_bufb+j++) = '\0';
            ++size_sum;
            if (arg_n == 1)
             {
              k = 2 + iter - 1 - 1;
              --iter;
             }
            if (arg_nn == 1)
             {
              if ( next_sv != 0 ) { k = next_sv; next_sv = 0; }
              else k = 3 + iter - 1 - 2;
              --iter;
              stat = 0;
             }
           }
         }

       }

      write_sum = j;

      if (fwrite(mem_bufb, sizeof(uint8_t), write_sum, fpout) != write_sum)
       { file_write_err(); exit(1); }

      if ( size_sum == size ) break;

     }

   }
  while (!feof (fpin) && read_sum == BUFSIZE);

  exit(0);

 }

size_t readtobuf (uint8_t *mem_buf, size_t buflen, FILE *fpin)

 {

  size_t read_sum, read_cnt;

  read_sum = 0;

  do
   {
    read_cnt = fread(mem_buf + read_sum, sizeof(uint8_t), buflen - read_sum, fpin);
    read_sum += read_cnt;
   }
  while (!feof (fpin) && !ferror (fpin) && read_sum < buflen);

  if(ferror(fpin))
   { file_read_err(); exit(1); }

  return read_sum;

  return 0;

 }


void ap_calc ( int start_val, long int size, ap_ctx *ap )

 {

  long sum, an, tmp_prev, tmp;

  tmp = size / start_val;
  tmp_prev = tmp + 1;

  do
   {

    an = start_val + (tmp - 1) * 1;

    sum = tmp * ( start_val + an ) / 2;

    if ( sum > size )
     {
      tmp_prev = tmp;
      tmp = tmp / 2;
     }
    else if ( (sum <= size) && ( (tmp_prev - tmp) == 1 ) ) break;
    else if (sum <= size)
     {
      tmp = ( tmp_prev + tmp ) / 2;
     }

   } while (1);

  ap->iter = tmp;
  ap->sum = sum;
  ap->an = an;

 }


void usage (void)
 {
  fputs("Test program - Part of v-tools\n\n", stderr);
  fputs("Usage:\n", stderr);
  fputs("\ttest [ -n | -nn ] [ -si | -sd | -sr ]\n", stderr);
  fputs("\t -fs size [ | -i FILE | -o FILE ] [ -h ]\n\n", stderr);
  fputs("\tEach argument can be given only once.\n", stderr);
  fputs("\t-i\t Input file. If not given takes input from /dev/urandom.\n", stderr);
  fputs("\t-o\t Output file; Truncating if exists. If not given output to stdout.\n", stderr);
  fputs("\t-fs size Output file size.\n\n", stderr);
  fputs("\t-n\t Output null separated bytes.\n", stderr);
  fputs("\t-nn\t Output double null enclosed bytes.\n", stderr);
  fputs("\t-si\t Output (one) incremental size bytes.\n", stderr);
  fputs("\t-sd\t Output (one) decremental size bytes.\n", stderr);
  fputs("\t-sr\t Output random size bytes.\n", stderr);
  fputs("\t-h\t Show help.\n", stderr);
 }

void opt_err (void)
 {
  fputs("Each argument can be given only once!\n", stderr);
 }

void opt_arg_err (void)
 {
  fputs("Neccessary argument for specified option not given!\n", stderr);
 }

void parm_unknown_err (char *arg)
 {
  fprintf(stderr, "Unknown argument given!: %s\n", arg);
 }

void file_open_err (void)
 {
  fputs("Could not open file for read/write!\n", stderr);
 }

void file_read_err (void)
 {
  fputs("Read Error! Exiting...\n", stderr);
 }

void file_write_err (void)
 {
  fputs("Write Error! Exiting...\n", stderr);
 }

void mem_alloc_err (void)
 {
  fputs("Error: Unable to Get Memory! Exiting...\n", stderr);
 }


