/* v-filestz.h */

/*

Copyright Notice:

Copyright (C) 2013 R Veera Kumar

This file is part of v-tools.

v-tools is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

v-tools is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with v-tools.  If not, see <http://www.gnu.org/licenses/>.

See the COPYING file distributed together for license information.

See the AUTHOR file distributed together for authors information.

*/

#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <string.h>

size_t ascii_stz ( uint8_t *data_in, uint8_t *data_out, size_t inlen );

size_t readtobuf ( uint8_t *mem_buf, size_t buflen, FILE *fpin );

void usage (void);

void version (void);

void opt_err (void);

void opt_arg_err (void);

void file_open_err (void);

void parm_unknown_err (char *arg);

void file_write_err (void);

void file_read_err (void);

void mem_alloc_err (void);

#define DESC "v-filestz - ASCII TEXT Sanitizer"
#define VERSION "0.1"
#define LICENSE "GNU GPL Version 3"

#define BUFSIZE 4096
