/* v-wrstrp.h */

/*

Copyright Notice:

Copyright (C) 2013 R Veera Kumar

This file is part of v-tools.

v-tools is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

v-tools is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with v-tools.  If not, see <http://www.gnu.org/licenses/>.

See the COPYING file distributed together for license information.

See the AUTHOR file distributed together for authors information.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void usage (void);

void version (void);

void opt_err (void);

void opt_arg_err (void);

void file_open_err (void);

void parm_one_at_time_err (void);

void parm_unknown_err (char *arg);

char * str_esc_proc (char * str, size_t * len);

void err_malloc_alloc (void);

#define DESC "v-wrstrp - Write a string to screen or file"
#define VERSION "0.1"
#define LICENSE "GNU GPL Version 3"

#ifdef BIG_CODE
#define L_OPT_ERR opt_err()
#define L_OPT_ARG_ERR opt_arg_err()
#define L_FILE_OPEN_ERR file_open_err()
#define L_PARM_ONE_AT_TIME_ERR parm_one_at_time_err()
#define L_PARM_UNKNOWN_ERR(ARG) parm_unknown_err(ARG)
#define L_ERR_MALLOC_ALLOC err_malloc_alloc()
#endif

#ifndef BIG_CODE
#define L_OPT_ERR
#define L_OPT_ARG_ERR
#define L_FILE_OPEN_ERR
#define L_PARM_ONE_AT_TIME_ERR
#define L_PARM_UNKNOWN_ERR(ARG)
#define L_ERR_MALLOC_ALLOC
#endif

